package Audio::OSS;
use strict;
use vars qw(@EXPORT_OK %EXPORT_TAGS @CONSTANTS);
push @EXPORT_OK, qw(
	SNDCTL_DSP_RESET
	SNDCTL_DSP_SYNC
	SNDCTL_DSP_SPEED
	SNDCTL_DSP_STEREO
	SNDCTL_DSP_GETBLKSIZE
	SNDCTL_DSP_SAMPLESIZE
	SNDCTL_DSP_CHANNELS
	SNDCTL_DSP_POST
	SNDCTL_DSP_SUBDIVIDE
	SNDCTL_DSP_SETFRAGMENT
	SNDCTL_DSP_GETOSPACE
	SNDCTL_DSP_GETISPACE
	SNDCTL_DSP_NONBLOCK
	SNDCTL_DSP_GETCAPS
	SNDCTL_DSP_GETFMTS
	SNDCTL_DSP_SETFMT
	SNDCTL_DSP_GETTRIGGER
	SNDCTL_DSP_SETTRIGGER
	SNDCTL_DSP_GETIPTR
	SNDCTL_DSP_GETOPTR
	SNDCTL_DSP_MAPINBUF
	SNDCTL_DSP_MAPOUTBUF
	SNDCTL_DSP_SETSYNCRO
	SNDCTL_DSP_SETDUPLEX
	SNDCTL_DSP_GETODELAY
	SNDCTL_DSP_PROFILE
	SOUND_PCM_READ_RATE
	SOUND_PCM_READ_CHANNELS
	SOUND_PCM_READ_BITS
	SOUND_PCM_READ_FILTER
	SOUND_MIXER_READ_VOLUME
	SOUND_MIXER_READ_RECSRC
	SOUND_MIXER_READ_DEVMASK
	SOUND_MIXER_READ_RECMASK
	SOUND_MIXER_READ_STEREODEVS
	SOUND_MIXER_READ_CAPS
	SOUND_MIXER_WRITE_VOLUME
	SOUND_MIXER_WRITE_RECSRC
	SOUND_MIXER_INFO
	SOUND_MIXER_AGC
	SOUND_MIXER_3DSE
	SOUND_MIXER_PRIVATE1
	SOUND_MIXER_PRIVATE2
	SOUND_MIXER_PRIVATE3
	SOUND_MIXER_PRIVATE4
	SOUND_MIXER_PRIVATE5
	SOUND_MIXER_GETLEVELS
	SOUND_MIXER_SETLEVELS
	OSS_GETVERSION
	SOUND_MIXER_NRDEVICES
	SOUND_MIXER_VOLUME
	SOUND_MIXER_BASS
	SOUND_MIXER_TREBLE
	SOUND_MIXER_SYNTH
	SOUND_MIXER_PCM
	SOUND_MIXER_SPEAKER
	SOUND_MIXER_LINE
	SOUND_MIXER_MIC
	SOUND_MIXER_CD
	SOUND_MIXER_IMIX
	SOUND_MIXER_ALTPCM
	SOUND_MIXER_RECLEV
	SOUND_MIXER_IGAIN
	SOUND_MIXER_OGAIN
	SOUND_MIXER_LINE1
	SOUND_MIXER_LINE2
	SOUND_MIXER_LINE3
	SOUND_MIXER_DIGITAL1
	SOUND_MIXER_DIGITAL2
	SOUND_MIXER_DIGITAL3
	SOUND_MIXER_PHONEIN
	SOUND_MIXER_PHONEOUT
	SOUND_MIXER_VIDEO
	SOUND_MIXER_RADIO
	SOUND_MIXER_MONITOR
	SOUND_MIXER_NONE
	SOUND_ONOFF_MIN
	SOUND_ONOFF_MAX
	SOUND_MIXER_RECSRC
	SOUND_MIXER_DEVMASK
	SOUND_MIXER_RECMASK
	SOUND_MIXER_CAPS
	SOUND_CAP_EXCL_INPUT
	SOUND_MIXER_STEREODEVS
	SOUND_MIXER_OUTSRC
	SOUND_MIXER_OUTMASK
	PCM_ENABLE_INPUT
	PCM_ENABLE_OUTPUT
	APF_NORMAL
	APF_NETWORK
	APF_CPUINTENS
	DSP_CAP_REVISION
	DSP_CAP_DUPLEX
	DSP_CAP_REALTIME
	DSP_CAP_BATCH
	DSP_CAP_COPROC
	DSP_CAP_TRIGGER
	DSP_CAP_MMAP
	AFMT_QUERY
	AFMT_MU_LAW
	AFMT_A_LAW
	AFMT_IMA_ADPCM
	AFMT_U8
	AFMT_S16_LE
	AFMT_S16_BE
	AFMT_S16_NE
	AFMT_S8
	AFMT_U16_LE
	AFMT_U16_BE
	AFMT_MPEG
	);
$EXPORT_TAGS{'ioctls'} = [qw(
	SNDCTL_DSP_RESET
	SNDCTL_DSP_SYNC
	SNDCTL_DSP_SPEED
	SNDCTL_DSP_STEREO
	SNDCTL_DSP_GETBLKSIZE
	SNDCTL_DSP_SAMPLESIZE
	SNDCTL_DSP_CHANNELS
	SNDCTL_DSP_POST
	SNDCTL_DSP_SUBDIVIDE
	SNDCTL_DSP_SETFRAGMENT
	SNDCTL_DSP_GETOSPACE
	SNDCTL_DSP_GETISPACE
	SNDCTL_DSP_NONBLOCK
	SNDCTL_DSP_GETCAPS
	SNDCTL_DSP_GETFMTS
	SNDCTL_DSP_SETFMT
	SNDCTL_DSP_GETTRIGGER
	SNDCTL_DSP_SETTRIGGER
	SNDCTL_DSP_GETIPTR
	SNDCTL_DSP_GETOPTR
	SNDCTL_DSP_MAPINBUF
	SNDCTL_DSP_MAPOUTBUF
	SNDCTL_DSP_SETSYNCRO
	SNDCTL_DSP_SETDUPLEX
	SNDCTL_DSP_GETODELAY
	SNDCTL_DSP_PROFILE
	SOUND_PCM_READ_RATE
	SOUND_PCM_READ_CHANNELS
	SOUND_PCM_READ_BITS
	SOUND_PCM_READ_FILTER
	SOUND_MIXER_READ_VOLUME
	SOUND_MIXER_READ_RECSRC
	SOUND_MIXER_READ_DEVMASK
	SOUND_MIXER_READ_RECMASK
	SOUND_MIXER_READ_STEREODEVS
	SOUND_MIXER_READ_CAPS
	SOUND_MIXER_WRITE_VOLUME
	SOUND_MIXER_WRITE_RECSRC
	SOUND_MIXER_INFO
	SOUND_MIXER_AGC
	SOUND_MIXER_3DSE
	SOUND_MIXER_PRIVATE1
	SOUND_MIXER_PRIVATE2
	SOUND_MIXER_PRIVATE3
	SOUND_MIXER_PRIVATE4
	SOUND_MIXER_PRIVATE5
	SOUND_MIXER_GETLEVELS
	SOUND_MIXER_SETLEVELS
	OSS_GETVERSION
	)];
$EXPORT_TAGS{'mixer'} = [qw(
	SOUND_MIXER_NRDEVICES
	SOUND_MIXER_VOLUME
	SOUND_MIXER_BASS
	SOUND_MIXER_TREBLE
	SOUND_MIXER_SYNTH
	SOUND_MIXER_PCM
	SOUND_MIXER_SPEAKER
	SOUND_MIXER_LINE
	SOUND_MIXER_MIC
	SOUND_MIXER_CD
	SOUND_MIXER_IMIX
	SOUND_MIXER_ALTPCM
	SOUND_MIXER_RECLEV
	SOUND_MIXER_IGAIN
	SOUND_MIXER_OGAIN
	SOUND_MIXER_LINE1
	SOUND_MIXER_LINE2
	SOUND_MIXER_LINE3
	SOUND_MIXER_DIGITAL1
	SOUND_MIXER_DIGITAL2
	SOUND_MIXER_DIGITAL3
	SOUND_MIXER_PHONEIN
	SOUND_MIXER_PHONEOUT
	SOUND_MIXER_VIDEO
	SOUND_MIXER_RADIO
	SOUND_MIXER_MONITOR
	SOUND_MIXER_NONE
	SOUND_ONOFF_MIN
	SOUND_ONOFF_MAX
	SOUND_MIXER_RECSRC
	SOUND_MIXER_DEVMASK
	SOUND_MIXER_RECMASK
	SOUND_MIXER_CAPS
	SOUND_CAP_EXCL_INPUT
	SOUND_MIXER_STEREODEVS
	SOUND_MIXER_OUTSRC
	SOUND_MIXER_OUTMASK
	)];
$EXPORT_TAGS{'misc'} = [qw(
	PCM_ENABLE_INPUT
	PCM_ENABLE_OUTPUT
	APF_NORMAL
	APF_NETWORK
	APF_CPUINTENS
	)];
$EXPORT_TAGS{'bind'} = [qw(
	)];
$EXPORT_TAGS{'caps'} = [qw(
	DSP_CAP_REVISION
	DSP_CAP_DUPLEX
	DSP_CAP_REALTIME
	DSP_CAP_BATCH
	DSP_CAP_COPROC
	DSP_CAP_TRIGGER
	DSP_CAP_MMAP
	)];
$EXPORT_TAGS{'formats'} = [qw(
	AFMT_QUERY
	AFMT_MU_LAW
	AFMT_A_LAW
	AFMT_IMA_ADPCM
	AFMT_U8
	AFMT_S16_LE
	AFMT_S16_BE
	AFMT_S16_NE
	AFMT_S8
	AFMT_U16_LE
	AFMT_U16_BE
	AFMT_MPEG
	)];
@CONSTANTS = (
	[ SNDCTL_DSP_RESET => 0x00005000 ],
	[ SNDCTL_DSP_SYNC => 0x00005001 ],
	[ SNDCTL_DSP_SPEED => 0x60045002 ],
	[ SNDCTL_DSP_STEREO => 0x60045003 ],
	[ SNDCTL_DSP_GETBLKSIZE => 0x60045004 ],
	[ SNDCTL_DSP_SAMPLESIZE => 0x60045005 ],
	[ SNDCTL_DSP_CHANNELS => 0x60045006 ],
	[ SNDCTL_DSP_POST => 0x00005008 ],
	[ SNDCTL_DSP_SUBDIVIDE => 0x60045009 ],
	[ SNDCTL_DSP_SETFRAGMENT => 0x6004500a ],
	[ SNDCTL_DSP_GETOSPACE => 0x2010500c ],
	[ SNDCTL_DSP_GETISPACE => 0x2010500d ],
	[ SNDCTL_DSP_NONBLOCK => 0x0000500e ],
	[ SNDCTL_DSP_GETCAPS => 0x2004500f ],
	[ SNDCTL_DSP_GETFMTS => 0x2004500b ],
	[ SNDCTL_DSP_SETFMT => 0x60045005 ],
	[ SNDCTL_DSP_GETTRIGGER => 0x20045010 ],
	[ SNDCTL_DSP_SETTRIGGER => 0x40045010 ],
	[ SNDCTL_DSP_GETIPTR => 0x200c5011 ],
	[ SNDCTL_DSP_GETOPTR => 0x200c5012 ],
	[ SNDCTL_DSP_MAPINBUF => 0x20085013 ],
	[ SNDCTL_DSP_MAPOUTBUF => 0x20085014 ],
	[ SNDCTL_DSP_SETSYNCRO => 0x00005015 ],
	[ SNDCTL_DSP_SETDUPLEX => 0x00005016 ],
	[ SNDCTL_DSP_GETODELAY => 0x20045017 ],
	[ SNDCTL_DSP_PROFILE => 0x40045017 ],
	[ SOUND_PCM_READ_RATE => 0x20045002 ],
	[ SOUND_PCM_READ_CHANNELS => 0x20045006 ],
	[ SOUND_PCM_READ_BITS => 0x20045005 ],
	[ SOUND_PCM_READ_FILTER => 0x20045007 ],
	[ SOUND_MIXER_READ_VOLUME => 0x20044d00 ],
	[ SOUND_MIXER_READ_RECSRC => 0x20044dff ],
	[ SOUND_MIXER_READ_DEVMASK => 0x20044dfe ],
	[ SOUND_MIXER_READ_RECMASK => 0x20044dfd ],
	[ SOUND_MIXER_READ_STEREODEVS => 0x20044dfb ],
	[ SOUND_MIXER_READ_CAPS => 0x20044dfc ],
	[ SOUND_MIXER_WRITE_VOLUME => 0x60044d00 ],
	[ SOUND_MIXER_WRITE_RECSRC => 0x60044dff ],
	[ SOUND_MIXER_INFO => 0x205c4d65 ],
	[ SOUND_MIXER_AGC => 0x60044d67 ],
	[ SOUND_MIXER_3DSE => 0x60044d68 ],
	[ SOUND_MIXER_PRIVATE1 => 0x60044d6f ],
	[ SOUND_MIXER_PRIVATE2 => 0x60044d70 ],
	[ SOUND_MIXER_PRIVATE3 => 0x60044d71 ],
	[ SOUND_MIXER_PRIVATE4 => 0x60044d72 ],
	[ SOUND_MIXER_PRIVATE5 => 0x60044d73 ],
	[ SOUND_MIXER_GETLEVELS => 0x60a44d74 ],
	[ SOUND_MIXER_SETLEVELS => 0x60a44d75 ],
	[ OSS_GETVERSION => 0x20044d76 ],
	[ SOUND_MIXER_NRDEVICES => 0x00000019 ],
	[ SOUND_MIXER_VOLUME => 0x00000000 ],
	[ SOUND_MIXER_BASS => 0x00000001 ],
	[ SOUND_MIXER_TREBLE => 0x00000002 ],
	[ SOUND_MIXER_SYNTH => 0x00000003 ],
	[ SOUND_MIXER_PCM => 0x00000004 ],
	[ SOUND_MIXER_SPEAKER => 0x00000005 ],
	[ SOUND_MIXER_LINE => 0x00000006 ],
	[ SOUND_MIXER_MIC => 0x00000007 ],
	[ SOUND_MIXER_CD => 0x00000008 ],
	[ SOUND_MIXER_IMIX => 0x00000009 ],
	[ SOUND_MIXER_ALTPCM => 0x0000000a ],
	[ SOUND_MIXER_RECLEV => 0x0000000b ],
	[ SOUND_MIXER_IGAIN => 0x0000000c ],
	[ SOUND_MIXER_OGAIN => 0x0000000d ],
	[ SOUND_MIXER_LINE1 => 0x0000000e ],
	[ SOUND_MIXER_LINE2 => 0x0000000f ],
	[ SOUND_MIXER_LINE3 => 0x00000010 ],
	[ SOUND_MIXER_DIGITAL1 => 0x00000011 ],
	[ SOUND_MIXER_DIGITAL2 => 0x00000012 ],
	[ SOUND_MIXER_DIGITAL3 => 0x00000013 ],
	[ SOUND_MIXER_PHONEIN => 0x00000014 ],
	[ SOUND_MIXER_PHONEOUT => 0x00000015 ],
	[ SOUND_MIXER_VIDEO => 0x00000016 ],
	[ SOUND_MIXER_RADIO => 0x00000017 ],
	[ SOUND_MIXER_MONITOR => 0x00000018 ],
	[ SOUND_MIXER_NONE => 0x0000001f ],
	[ SOUND_ONOFF_MIN => 0x0000001c ],
	[ SOUND_ONOFF_MAX => 0x0000001e ],
	[ SOUND_MIXER_RECSRC => 0x000000ff ],
	[ SOUND_MIXER_DEVMASK => 0x000000fe ],
	[ SOUND_MIXER_RECMASK => 0x000000fd ],
	[ SOUND_MIXER_CAPS => 0x000000fc ],
	[ SOUND_CAP_EXCL_INPUT => 0x00000001 ],
	[ SOUND_MIXER_STEREODEVS => 0x000000fb ],
	[ SOUND_MIXER_OUTSRC => 0x000000fa ],
	[ SOUND_MIXER_OUTMASK => 0x000000f9 ],
	[ PCM_ENABLE_INPUT => 0x00000001 ],
	[ PCM_ENABLE_OUTPUT => 0x00000002 ],
	[ APF_NORMAL => 0x00000000 ],
	[ APF_NETWORK => 0x00000001 ],
	[ APF_CPUINTENS => 0x00000002 ],
	[ DSP_CAP_REVISION => 0x000000ff ],
	[ DSP_CAP_DUPLEX => 0x00000100 ],
	[ DSP_CAP_REALTIME => 0x00000200 ],
	[ DSP_CAP_BATCH => 0x00000400 ],
	[ DSP_CAP_COPROC => 0x00000800 ],
	[ DSP_CAP_TRIGGER => 0x00001000 ],
	[ DSP_CAP_MMAP => 0x00002000 ],
	[ AFMT_QUERY => 0x00000000 ],
	[ AFMT_MU_LAW => 0x00000001 ],
	[ AFMT_A_LAW => 0x00000002 ],
	[ AFMT_IMA_ADPCM => 0x00000004 ],
	[ AFMT_U8 => 0x00000008 ],
	[ AFMT_S16_LE => 0x00000010 ],
	[ AFMT_S16_BE => 0x00000020 ],
	[ AFMT_S16_NE => 0x00000020 ],
	[ AFMT_S8 => 0x00000040 ],
	[ AFMT_U16_LE => 0x00000080 ],
	[ AFMT_U16_BE => 0x00000100 ],
	[ AFMT_MPEG => 0x00000200 ],
    );

sub make_const {
    my ($const, $val) = @_;

    no strict 'refs';
    *$const = sub () { $val };
}

foreach (@CONSTANTS) {
    make_const(@$_);
}
1;
